# stylelens-product
This is a API document for Product DB

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.0.1
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com//.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com//.git`)

Then import the package:
```python
import stylelens_product 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import stylelens_product
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import stylelens_product
from stylelens_product.rest import ApiException
from pprint import pprint
# create an instance of the API class
api_instance = stylelens_product.ImageApi()
body = stylelens_product.Image() # Image | Product object that needs to be added to the db.

try:
    # Added a new Image
    api_response = api_instance.add_image(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ImageApi->add_image: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://product.stylelens.io*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ImageApi* | [**add_image**](docs/ImageApi.md#add_image) | **POST** /images | Added a new Image
*ObjectApi* | [**add_object**](docs/ObjectApi.md#add_object) | **POST** /objects | Added a new Object
*ObjectApi* | [**get_object_by_id**](docs/ObjectApi.md#get_object_by_id) | **GET** /objects/{objectId} | Find Object by ID
*ProductApi* | [**add_product**](docs/ProductApi.md#add_product) | **POST** /products | Added a new Product
*ProductApi* | [**delete_product_by_id**](docs/ProductApi.md#delete_product_by_id) | **DELETE** /products/{productId} | Deletes a Product
*ProductApi* | [**get_product_by_id**](docs/ProductApi.md#get_product_by_id) | **GET** /products/{productId} | Find Product by ID
*ProductApi* | [**get_products_by_hostcode**](docs/ProductApi.md#get_products_by_hostcode) | **GET** /products/hosts/{hostCode} | Get Product by host_code
*ProductApi* | [**get_products_by_hostcode_and_product_no**](docs/ProductApi.md#get_products_by_hostcode_and_product_no) | **GET** /products/hosts/{hostCode}/products/{productNo} | Get Product by hostCode and productNo
*ProductApi* | [**get_products_by_ids**](docs/ProductApi.md#get_products_by_ids) | **GET** /products | Find Products by IDs
*ProductApi* | [**get_products_by_image_id_and_object_id**](docs/ProductApi.md#get_products_by_image_id_and_object_id) | **GET** /products/images/{imageId}/objects/{objectId} | Get Products by imageId and objectId
*ProductApi* | [**update_product**](docs/ProductApi.md#update_product) | **PUT** /products | Update an existing Product
*VersionApi* | [**add_version**](docs/VersionApi.md#add_version) | **POST** /versions | Add a new Version
*VersionApi* | [**get_latest_version**](docs/VersionApi.md#get_latest_version) | **GET** /versions/latest | Gat latest Version
*VersionApi* | [**get_version_by_id**](docs/VersionApi.md#get_version_by_id) | **GET** /versions/{versionId} | Gat Version by ID


## Documentation For Models

 - [AddImageResponse](docs/AddImageResponse.md)
 - [AddImageResponseData](docs/AddImageResponseData.md)
 - [AddObjectResponse](docs/AddObjectResponse.md)
 - [AddObjectResponseData](docs/AddObjectResponseData.md)
 - [AddProductResponse](docs/AddProductResponse.md)
 - [AddProductResponseData](docs/AddProductResponseData.md)
 - [AddVersionResponse](docs/AddVersionResponse.md)
 - [AddVersionResponseData](docs/AddVersionResponseData.md)
 - [BoxArray](docs/BoxArray.md)
 - [BoxObject](docs/BoxObject.md)
 - [BoxesArray](docs/BoxesArray.md)
 - [DeleteProductResponse](docs/DeleteProductResponse.md)
 - [Feedback](docs/Feedback.md)
 - [GetObjectResponse](docs/GetObjectResponse.md)
 - [GetProductResponse](docs/GetProductResponse.md)
 - [GetProductsResponse](docs/GetProductsResponse.md)
 - [GetVersionResponse](docs/GetVersionResponse.md)
 - [Image](docs/Image.md)
 - [LatestVersionResponse](docs/LatestVersionResponse.md)
 - [Object](docs/Object.md)
 - [Product](docs/Product.md)
 - [SubImage](docs/SubImage.md)
 - [UpdateProductResponse](docs/UpdateProductResponse.md)
 - [Version](docs/Version.md)
 - [Writer](docs/Writer.md)


## Documentation For Authorization


## api_key

- **Type**: API key
- **API key parameter name**: api_key
- **Location**: HTTP header


## Author

master@bluehack.net

